import { Graph } from '../Graphs/Graph.js';
import { Metadata } from '../Metadata.js';
import { Socket } from '../Sockets/Socket.js';
import { NodeDescription } from './Registry/NodeDescription.js';
export declare class Node {
    readonly description: NodeDescription;
    readonly graph: Graph;
    readonly inputSockets: Socket[];
    readonly outputSockets: Socket[];
    id: string;
    label: string;
    metadata: Metadata;
    constructor(description: NodeDescription, graph: Graph, inputSockets?: Socket[], outputSockets?: Socket[]);
    readInput<T>(inputName: string): T;
    writeOutput<T>(outputName: string, value: T): void;
}
//# sourceMappingURL=Node.d.ts.map