import { Socket } from '../../Sockets/Socket.js';
import { ImmediateNode } from '../ImmediateNode.js';
export class In1Out1FuncNode extends ImmediateNode {
    constructor(description, graph, inputValueTypes, outputValueType, unaryEvalFunc, inputNames = ['a']) {
        if (inputValueTypes.length !== 1) {
            throw new Error(`inputValueTypes must have a length of 1, it is instead ${inputValueTypes.length}`);
        }
        if (inputNames.length !== 1) {
            throw new Error(`inputNames must have a length of 1, it is instead ${inputNames.length}`);
        }
        super(description, graph, [new Socket(inputValueTypes[0], inputNames[0])], [new Socket(outputValueType, 'result')], () => {
            this.writeOutput('result', this.unaryEvalFunc(this.readInput(inputNames[0])));
        });
        this.unaryEvalFunc = unaryEvalFunc;
        this.inputNames = inputNames;
    }
}
//# sourceMappingURL=In1Out1FuncNode.js.map