import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class SetVariable extends Node {
    constructor(name, valueTypeName) {
        super('Action', name, [
            new Socket('flow', 'flow'),
            new Socket('id', 'variable'),
            new Socket(valueTypeName, 'value')
        ], [new Socket('flow', 'flow')], (context) => {
            const variableId = context.readInput('variable');
            const variable = context.getVariable(variableId);
            if (this.valueTypeName !== variable.valueTypeName) {
                throw new Error(`type mismatch between VariableSet ${this.valueTypeName} and variable ${variable.valueTypeName}`);
            }
            variable.set(context.readInput('value'));
        });
        this.valueTypeName = valueTypeName;
    }
}
//# sourceMappingURL=SetVariable.js.map