import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class OnCustomEvent extends Node {
    constructor() {
        super('Event', 'event/customEvent', [new Socket('id', 'customEvent')], [new Socket('flow', 'flow')], (context) => {
            const customEventId = context.readInput('customEvent');
            const customEvent = context.getCustomEvent(customEventId);
            customEvent.eventEmitter.addListener(() => {
                context.commit('flow');
            });
        });
        this.evaluateOnStartup = true;
        this.async = true;
        this.interruptibleAsync = true;
    }
}
//# sourceMappingURL=OnCustomEvent.js.map