import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class OnLifecycleEnd extends Node {
    constructor() {
        super('Event', 'lifecycle/end', [], [new Socket('flow', 'flow')], (context) => {
            const onEndEvent = () => {
                context.commit('flow');
            };
            const lifecycleEvents = context.graph.registry.implementations.get('ILifecycleEventEmitter');
            lifecycleEvents.endEvent.addListener(onEndEvent);
            context.onAsyncCancelled.addListener(() => {
                lifecycleEvents.endEvent.removeListener(onEndEvent);
            });
        });
        this.async = true;
        this.evaluateOnStartup = true;
        this.interruptibleAsync = true;
    }
}
//# sourceMappingURL=OnLifecycleEnd.js.map