import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class OnLifecycleStart extends Node {
    constructor() {
        super('Event', 'lifecycle/start', [], [new Socket('flow', 'flow')], (context) => {
            const onStartEvent = () => {
                context.commit('flow');
            };
            const lifecycleEvents = context.graph.registry.implementations.get('ILifecycleEventEmitter');
            lifecycleEvents.startEvent.addListener(onStartEvent);
            context.onAsyncCancelled.addListener(() => {
                lifecycleEvents.startEvent.removeListener(onStartEvent);
            });
        });
        this.async = true;
        this.evaluateOnStartup = true;
        this.interruptibleAsync = true;
    }
}
//# sourceMappingURL=OnLifecycleStart.js.map