import { FlowNode } from '../../../Nodes/FlowNode.js';
import { NodeDescription } from '../../../Nodes/Registry/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class ForLoop extends FlowNode {
    constructor(description, graph) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket('integer', 'startIndex'),
            new Socket('integer', 'endIndex')
        ], [
            new Socket('flow', 'loopBody'),
            new Socket('integer', 'index'),
            new Socket('flow', 'completed')
        ]);
    }
    triggered(fiber, triggeringSocketName) {
        const startIndex = this.readInput('startIndex');
        const endIndex = this.readInput('endIndex');
        const loopBodyIteration = (i) => {
            if (i < endIndex) {
                this.writeOutput('index', i);
                fiber.commit(this, 'loopBody', () => {
                    loopBodyIteration(i + 1n);
                });
            }
            else {
                fiber.commit(this, 'completed');
            }
        };
        loopBodyIteration(startIndex);
    }
}
ForLoop.Description = new NodeDescription('flow/forLoop', 'Flow', 'For Loop', (description, graph) => new ForLoop(description, graph));
//# sourceMappingURL=ForLoop.js.map