import { Node } from '../../../Nodes/Node.js';
import { Socket } from '../../../Sockets/Socket.js';
export class Delay extends Node {
    constructor() {
        super('Time', 'time/delay', [new Socket('flow', 'flow'), new Socket('float', 'duration')], [new Socket('flow', 'flow')], (context) => {
            let timeIsCancelled = false;
            setTimeout(() => {
                if (timeIsCancelled) {
                    return;
                }
                context.commit('flow');
                context.finish();
            }, context.readInput('duration') * 1000);
            context.onAsyncCancelled.addListener(() => {
                timeIsCancelled = true;
            });
        });
        this.async = true;
    }
}
//# sourceMappingURL=Delay.js.map