import { ImmediateNode } from '../../../Nodes/ImmediateNode.js';
import { NodeDescription } from '../../../Nodes/Registry/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class VariableGet extends ImmediateNode {
    constructor(description, graph, variable) {
        super(description, graph, [], [new Socket(variable.valueTypeName, 'value', undefined, variable.name)], () => {
            this.writeOutput('value', variable.get());
        });
        this.variable = variable;
    }
    static GetDescription(graph, variableId) {
        const variable = graph.variables[variableId];
        return new NodeDescription(`variable/get/${variable.id}`, 'Query', '', (description, graph) => new VariableGet(description, graph, variable));
    }
}
//# sourceMappingURL=VariableGet.js.map