import { FlowNode } from '../../../Nodes/FlowNode.js';
import { NodeDescription } from '../../../Nodes/Registry/NodeDescription.js';
import { Socket } from '../../../Sockets/Socket.js';
export class VariableSet extends FlowNode {
    constructor(description, graph, variable) {
        super(description, graph, [
            new Socket('flow', 'flow'),
            new Socket(variable.valueTypeName, 'value', undefined, variable.name)
        ], [new Socket('flow', 'flow')]);
        this.variable = variable;
    }
    static GetDescription(graph, variableId) {
        const variable = graph.variables[variableId];
        return new NodeDescription(`variable/set/${variable.id}`, 'Action', `Set`, (description, graph) => new VariableSet(description, graph, variable));
    }
    triggered(fiber, triggeredSocketName) {
        this.variable.set(this.readInput('value'));
        fiber.commit(this, 'flow');
    }
}
//# sourceMappingURL=VariableSet.js.map