import { NodeDescription } from '../../Nodes/Registry/NodeDescription.js';
import { In1Out1FuncNode } from '../../Nodes/Templates/In1Out1FuncNode.js';
import { toCamelCase } from '../../toCamelCase.js';
export function registerSerializersForValueType(registry, valueTypeName) {
    const camelCaseValueTypeName = toCamelCase(valueTypeName);
    registry.nodes.register(new NodeDescription(`math/to${camelCaseValueTypeName}/string`, 'Logic', `To ${camelCaseValueTypeName}`, (graph, nodeType) => new In1Out1FuncNode(graph, nodeType, ['string'], valueTypeName, (a) => registry.values.get(valueTypeName).deserialize(a))), new NodeDescription(`math/toString/${valueTypeName}`, 'Logic', 'To String', (graph, nodeType) => new In1Out1FuncNode(graph, nodeType, [valueTypeName], 'string', (a) => registry.values.get(valueTypeName).serialize(a))));
}
//# sourceMappingURL=registerSerializersForValueType.js.map