import { ImmediateNode } from '../../../Nodes/ImmediateNode.js';
import { Socket } from '../../../Sockets/Socket.js';
export class VecElements extends ImmediateNode {
    constructor(description, graph, valueTypeName, elementNames = ['x', 'y', 'z', 'w'], toArray) {
        super(description, graph, [new Socket(valueTypeName, 'value')], elementNames.map((elementName) => new Socket('float', elementName)), () => {
            const value = this.readInput('value');
            const elementValues = elementNames.map(() => 0);
            toArray(value, elementValues, 0);
            elementNames.forEach((elementName, index) => this.writeOutput(elementName, elementValues[index]));
        });
    }
}
//# sourceMappingURL=VecElements.js.map